<template>
  <div class="container-fluid page">
    <div class="row pt-5">
      <div class="col-sm-4"></div>
      
      <div v-if="isLoading" class="text-center col-sm-4 bg-white my-5 p-4">
        <vue-loaders class="p-5" name="ball-beat" color="#fa8357" scale="2"></vue-loaders>
      </div>
      <div v-else class="col-sm-4 bg-white my-5 p-4 card">

        <!-- Sign In -->
        <div v-if="currentStep==0">
          <h2 class="text-primary text-center mb-3">Sign In</h2>
          <div class="alert alert-danger" v-if="errorMessage.length > 0">{{errorMessage}}</div>

          <form :class=" toChekLogin ? 'was-validated' : ''" @submit="login">
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Email address</label>
              <input type="email" class="form-control" v-model="user.email" required 
              placeholder="Enter email">
              <div class="invalid-feedback">
                Enter your email address!
              </div>
            </div>
            <div class="form-group mt-2">
              <label for="password" class="mt-2 text-primary2">Password</label>
              <div class="input-group">
                <input :type="inputPwd ? 'password' : 'text'" minlength="8" class="form-control form-control-min"
                  title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character"
                  pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}"
                  v-model="user.password" required placeholder="Enter password">
                  
                <div class="input-group-prepend btn btn-outline-secondary" @click="inputPwd=!inputPwd">
                  <span  class="" id="inputGroupPrepend">
                    <i v-if="inputPwd==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div class="invalid-feedback">
                  Enter your Password!
                </div>

              </div>
            </div>

            <div class="col-sm text-right mt-3">
              <small class="text-primary c-pointer" @click="currentStep=2">Forgot Password?</small> 
            </div>

            <div class="form-group text-center" @click="toChekLogin=true">
              <input type="submit" class="btn btn-primary mt-4 col-sm-12" value="Sign in">
            </div>

            <!-- <div class="text-center mt-4">
              <small>D'ont have account? 
                <span class="text-primary c-pointer" @click="currentStep=1">sign up!</span> 
              </small>
            </div> -->
          </form>
        </div>
        
        <!-- Signup -->
        <div v-if="currentStep==1">
          <h2 class="text-primary text-center mb-3">Sign Up</h2>
          <div class="alert alert-danger" v-if="errorMessage.length > 0">{{errorMessage}}</div>

          <form :class=" toCheckRegister ? 'was-validated' : '' "  @submit="register">
            <div class="form-group">
              <label for="firstname" class="mt-2  text-primary2">First name</label>
              <input  class="form-control" v-model="newUser.firstname" required 
              placeholder="First name">
              <div class="invalid-feedback">
                Enter your First name!
              </div>
            </div>
            <div class="form-group">
              <label for="lastname" class="mt-2 text-primary2">Last name</label>
              <input  class="form-control text-uppercase" v-model="newUser.lastname" required 
              placeholder="Last name">
              <div class="invalid-feedback">
                Enter your Last name!
              </div>
            </div>
            <div class="form-group">
              <label for="password" class="mt-2 text-primary2">Email address</label>
              <input type="email" class="form-control " v-model="newUser.email" required 
              placeholder="Enter email">
              <div class="invalid-feedback">
                Enter your email address!
              </div>
            </div>
            <div class="form-group mt-2">
              <label for="password" class="mt-2 text-primary2">Password</label>
              <div class="input-group">
                <input :type="inputPwd2 ? 'password' : 'text'" minlength="8" class="form-control form-control-min"
                  title="At least 8 characters, a number, an upper case letter, a lower case letter and a special character"
                  pattern="(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[-+!#*$@%_]).{8,}" v-model="newUser.password" required 
                  placeholder="Enter password">

                <div class="input-group-prepend btn btn-outline-secondary" @click="inputPwd2=!inputPwd2">
                  <span class="" id="inputGroupPrepend">
                    <i v-if="inputPwd2==true" class="fa fa-eye"></i>
                    <i v-else class="fa fa-eye-slash"></i>
                  </span>
                </div>
                <div class="invalid-feedback">
                  Enter your Password!
                </div>
              </div>
            </div>

            <div class="form-group text-center" @click="toCheckRegister = true">
              <input type="submit" class="btn btn-primary mt-4 col-sm-12" value="Sign-up">
            </div>

            <div class="text-center mt-4">
              <small>Already registered? 
                <span class="text-primary c-pointer" @click="currentStep=0">sign in!</span> 
              </small>
            </div>
          </form>
        </div>

        <!-- Forgot password -->
        <div v-if="currentStep==2">
          <h2 class="text-primary text-center mb-3">Forgot password</h2>
          <div class="alert alert-danger" v-if="errorMessage.length > 0">{{errorMessage}}</div>

          <form :class=" toCheckForgotPwd ? 'was-validated' : '' "  @submit="forgotpwd">
            <div class="form-group">
              <label for="password" class="mt-2 mb-1 text-primary2">Email address</label>
              <input type="email" class="form-control" v-model="email" required 
              placeholder="Enter email">
              <div class="invalid-feedback">
                Enter your email address!
              </div>
            </div>


            <div class="form-group text-center" @click="toCheckForgotPwd = true">
              <input type="submit" class="btn btn-primary mt-4 col-sm-12" value="Forgot password">
            </div>

            <div class="text-center mt-4">
              <small>Already registered ? 
                <span class="text-primary c-pointer" @click="currentStep=0">sign in!</span> 
              </small>
            </div>
          </form>
        </div>
        
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import CryptoJS from 'crypto-js';
// const CryptoJS = require("crypto-js");

export default {
  data(){
    return {
      newUser: {
        email: '',
        password: '',
        firstname: '',
        lastname: ''
      },

      user: {
        email: '',
        password: ''
      },
      email: '',
      errorMessage: '',
      currentStep: 0,

      toChekLogin: false,
      toCheckRegister: false,
      toCheckForgotPwd: false,
      isLoading: false,

      inputPwd: true,
      inputPwd2: true,

    }
  },
  mounted(){
    this.currentStep = 0;
    this.init();
    // this.test();
  },
  methods: {
    test(){
      // Encrypt
      let ciphertext = CryptoJS.AES.encrypt('EverydayOOO', 'beaud@ejima.com').toString();
      console.log("My cypher ", ciphertext);

      // Decrypt
      var bytes  = CryptoJS.AES.decrypt(ciphertext, 'beaud@ejima.com');
      console.log("My decrypt text", bytes); 

      var originalText = bytes.toString(CryptoJS.enc.Utf8);

      console.log("My original text", originalText); 

    },
    init(){
      if(localStorage.getItem('token') && localStorage.getItem('token').length > 20 ){
        // this.$alertify.success('Vous êtes déjà connecté ');
        this.next();
        console.log("Our token", localStorage.getItem('token'));
      }

    },
    login(e){
      this.isLoading=true;
      e.preventDefault();

      const signin = {
        email: this.user.email,
        password: this.user.password
        // password: this.encryptPassword(this.user.password)
      }

      this.$service.login(signin, (data) => {
        this.isLoading=false;
        console.log("Response : ",data);

        if(data.status == 200){
          this.errorMessage = '';
          localStorage.setItem('token', data.token);
          localStorage.setItem('userInfos', JSON.stringify(data.user));
          // this.$store.commit('getUserInfo');
          this.$alertify.success('Connexion établie ');
          this.next();

        } else {
          if(data.status == 409){
            this.$alertify.alert('Adresse email non confirmé!', 
              `L'adresse email de votre compte n'a pas encore été confirmée. Veuillez consulter votre 
              boite mail pour finaliser votre inscription. Merci`
            );
          } 
          return this.errorMessage = data.message;
        }

      });
    },
    encryptPassword(password){
      return CryptoJS.AES.encrypt(''+password, 'beaud@ejima.com').toString();
    }, 
    register(e){
      this.isLoading=true;
      e.preventDefault();

      const signup = {
        firstname: this.newUser.firstname,
        lastname: this.newUser.lastname,
        email: this.newUser.email,
        password: this.newUser.password
        // password: this.encryptPassword(this.newUser.password)
      }

      this.$service.register(signup, (data) => {
        this.isLoading=false;
        console.log("Response : ",data);

        if(data.status == 200){
          this.errorMessage = '';
          this.newUser = {
            email: '',
            password: '',
            firstname: '',
            lastname: ''
          }
          this.currentStep=0;

          if(data.sendmail && data.sendmail==true){
            this.$alertify.alert('Inscription effectuée avec succès!', 
              `Nous venons de vous envoyer un mail de confirmation de compte. Veuillez Consulter votre 
              boite mail pour finaliser votre inscription. Merci`
            );
          }
          // this.$alertify.success('Inscripton éffectuée. Veuillez vous connecter!');
        } else {
          return this.errorMessage = data.message;
        }

      });
    
    },
    forgotpwd(e){
      this.isLoading=true;
      e.preventDefault();

      this.$service.post('/users/forget-password', {email: this.email}, (data) => {
        this.isLoading=false;
        console.log("Response : ",data);

        if(data.status == 200){
          this.errorMessage = '';
          this.$alertify.success('Email send ');
        } else {
          return this.errorMessage = data.message;
        }
      });
    },
    next(){
      this.$router.push({ path: '/home' });
    }
  }
  
}
</script>


<style scoped >

  .form-group .text-primary2 {
    font-weight: 800;
    margin: 4px 1px;

  }

</style>